<?php defined('BASEPATH') OR exit('No direct script access allowed');

/**
 * 阿里大于api
 * @author Bob
 */
class Sms
{
    private $accessKeyId;
    
    private $accessKeySecret;
    private $sign;

    public $connectTimeout = 3000;//3秒

    public $readTimeout = 80000;//80秒
    protected $time;

    
    public function __construct()
    {
        $this->CI =& get_instance();
        $this->CI->load->config('api', true);
        $this->accessKeyId = trim($this->CI->config->item('smsbao_key_id', 'api'));
        $this->accessKeySecret = trim($this->CI->config->item('smsbao_key_secret', 'api'));
        $this->sign = trim($this->CI->config->item('smsbao_sign', 'api'));
    }


    public function send($phone, $data = [], $action = 'verify')
    {
        $this->time = now();

        /** 不开启发送短信功能默认返回成功 */
        if ( $this->CI->config->item('open_send_sms') == 'N' )
        {
            return ['status' => TRUE, 'msg' => "已关闭发送短信功能"];
        }

        /** @var 判断手机号码格式 $new_phone */
        $new_phone = [];
        if (stripos($phone, ',') !== FALSE)
        {
            $phone = explode(',', $phone);
            foreach ($phone AS $k => $p)
            {
                if (is_phone($p))
                {
                    $new_phone[] = $p;
                }
            }
        }
        elseif (is_phone($phone))
        {
            $new_phone[] = $phone;
        }

        /** 手机号码格式不正确 */
            if (empty($new_phone))
            {
                return ['status' => FALSE, 'msg' => "请输入正确的手机号码"];
            }
            $smsapi = "http://api.smsbao.com/";
            $user = $this->accessKeyId; //短信平台帐号
            $pass = md5($this->accessKeySecret); //短信平台密码
            $content='【'.$this->sign.'】'."您的验证码{$data['code']},该验证码5分钟内有效,请勿泄漏于他人.";//要发送的短信内容
            $mobile = implode(',', (array)$new_phone);//要发送短信的手机号码
            $sendurl = $smsapi."sms?u=".$user."&p=".$pass."&m=".$mobile."&c=".urlencode($content);
            /** 对数据进行数组处理 */
            $reason           = $this->curl($sendurl);
            if ($reason === '0')
            {
                $result['msg'] = '发送成功';
                $result['status'] = TRUE;
            }
            else
            {
                $result['msg'] = '发送失败';
                $result['status'] = false;
            }

        /** 短信发送记录 */
        $this->CI->load->model('sms/logsm', 'sms_logs');
        foreach ($new_phone AS $phone)
        {
            $logs = [
                'phone'		=> $phone,
                'contents'	=> $content,
                'status'	=> ($reason==='0' ? 1 : 0 ),
                'send_time'	=> $this->time,
            ];
            $this->CI->sms_logs->save($logs);
        }

        return $result;
    }

    
    /**
     * 发送短信
     * @param $url
     * @author Bob
     * @return mixed
     * @throws Exception
     */
    public function curl ($url)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_FAILONERROR, FALSE);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        if ($this->readTimeout)
        {
            curl_setopt($ch, CURLOPT_TIMEOUT, $this->readTimeout);
        }
        
        if ($this->connectTimeout)
        {
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $this->connectTimeout);
        }
        
        //https 请求
        if (strlen($url) > 5 && strtolower(substr($url, 0, 5)) == "https")
        {
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        }
        
        $reponse = curl_exec($ch);
        
        if (curl_errno($ch))
        {
            throw new Exception(curl_error($ch), 0);
        }
        curl_close($ch);
        
        return $reponse;
    }
}